Index: src/hugo/skeletons/graph.h
===================================================================
--- src/hugo/skeletons/graph.h	(revision 732)
+++ src/hugo/skeletons/graph.h	(revision 774)
@@ -35,28 +35,30 @@
     public:
       /// Defalult constructor.
-      StaticGraphSkeleton() {}
+      StaticGraphSkeleton() { }
       ///Copy consructor.
 
       ///\todo It is not clear, what we expect from a copy constructor.
       ///E.g. How to assign the nodes/edges to each other? What about maps?
-      StaticGraphSkeleton(const StaticGraphSkeleton &G) {}
-
-      /// The base type of the node iterators.
-
-      /// This is the base type of each node iterators,
-      /// thus each kind of node iterator will convert to this.
+      StaticGraphSkeleton(const StaticGraphSkeleton& g) { }
+
+      /// The base type of node iterators, 
+      /// or in other words, the trivial node iterator.
+
+      /// This is the base type of each node iterator,
+      /// thus each kind of node iterator converts to this.
+      /// More precisely each kind of node iterator have to be inherited 
+      /// from the trivial node iterator.
       class Node {
       public:
 	/// @warning The default constructor sets the iterator
 	/// to an undefined value.
-	Node() {}   //FIXME
+	Node() { }
+	/// Copy constructor.
+	Node(const Node&) { }
 	/// Invalid constructor \& conversion.
 
 	/// This constructor initializes the iterator to be invalid.
 	/// \sa Invalid for more details.
-
-	Node(Invalid) {}
-	//Node(const Node &) {}
-
+	Node(Invalid) { }
 	/// Two iterators are equal if and only if they point to the
 	/// same object or both are invalid.
@@ -74,8 +76,8 @@
       /// This iterator goes through each node.
       /// Its usage is quite simple, for example you can count the number
-      /// of nodes in graph \c G of type \c Graph like this:
+      /// of nodes in graph \c g of type \c Graph like this:
       /// \code
-      ///int count=0;
-      ///for(Graph::NodeIt n(G);G.valid(n);G.next(n)) count++;
+      /// int count=0;
+      /// for (Graph::NodeIt n(g); g.valid(n); ++n) ++count;
       /// \endcode
       class NodeIt : public Node {
@@ -83,15 +85,20 @@
 	/// @warning The default constructor sets the iterator
 	/// to an undefined value.
-	NodeIt() {} //FIXME
+	NodeIt() { }
+	/// Copy constructor.
+	NodeIt(const NodeIt&) { }
 	/// Invalid constructor \& conversion.
 
-	/// Initialize the iterator to be invalid
+	/// Initialize the iterator to be invalid.
 	/// \sa Invalid for more details.
-	NodeIt(Invalid) {}
-	/// Sets the iterator to the first node of \c G.
-	NodeIt(const StaticGraphSkeleton &) {}
-	/// @warning The default constructor sets the iterator
-	/// to an undefined value.
-	NodeIt(const NodeIt &n) : Node(n) {}
+	NodeIt(Invalid) { }
+	/// Sets the iterator to the first node of \c g.
+	NodeIt(const StaticGraphSkeleton& g) { }
+	/// Sets the iterator to the node of \c g pointed by the trivial 
+	/// iterator n. This feature necessitates that each time we 
+	/// iterate the node-set, the iteration order is the same.
+	NodeIt(const StaticGraphSkeleton& g, const Node& n) { }
+	/// Assign the iterator to the next node.
+	NodeIt& operator++() { return *this; }
       };
     
@@ -102,7 +109,9 @@
 	/// @warning The default constructor sets the iterator
 	/// to an undefined value.
-	Edge() {}   //FIXME
-	/// Initialize the iterator to be invalid
-	Edge(Invalid) {}
+	Edge() { }
+	/// Copy constructor.
+	Edge(const Edge&) { }
+	/// Initialize the iterator to be invalid.
+	Edge(Invalid) { }
 	/// Two iterators are equal if and only if they point to the
 	/// same object or both are invalid.
@@ -118,8 +127,8 @@
       /// Its usage is quite simple, for example you can count the number
       /// of outgoing edges of a node \c n
-      /// in graph \c G of type \c Graph as follows.
+      /// in graph \c g of type \c Graph as follows.
       /// \code
-      ///int count=0;
-      ///for(Graph::OutEdgeIt e(G,n);G.valid(e);G.next(e)) count++;
+      /// int count=0;
+      /// for (Graph::OutEdgeIt e(g, n); g.valid(e); ++e) ++count;
       /// \endcode
     
@@ -128,7 +137,9 @@
 	/// @warning The default constructor sets the iterator
 	/// to an undefined value.
-	OutEdgeIt() {}
-	/// Initialize the iterator to be invalid
-	OutEdgeIt(Invalid) {}
+	OutEdgeIt() { }
+	/// Copy constructor.
+	OutEdgeIt(const OutEdgeIt&) { }
+	/// Initialize the iterator to be invalid.
+	OutEdgeIt(Invalid) { }
 	/// This constructor sets the iterator to first outgoing edge.
     
@@ -136,6 +147,12 @@
 	/// node
 	///@param n the node
-	///@param G the graph
-	OutEdgeIt(const StaticGraphSkeleton &, Node) {}
+	///@param g the graph
+	OutEdgeIt(const StaticGraphSkeleton& g, const Node& n) { }
+	/// Sets the iterator to the value of the trivial iterator \c e.
+	/// This feature necessitates that each time we 
+	/// iterate the edge-set, the iteration order is the same.
+	OutEdgeIt(const StaticGraphSkeleton& g, const Edge& e) { }
+	/// Assign the iterator to the next outedge of the corresponding node.
+	OutEdgeIt& operator++() { return *this; }
       };
 
@@ -146,8 +163,8 @@
       /// Its usage is quite simple, for example you can count the number
       /// of outgoing edges of a node \c n
-      /// in graph \c G of type \c Graph as follows.
+      /// in graph \c g of type \c Graph as follows.
       /// \code
-      ///int count=0;
-      ///for(Graph::InEdgeIt e(G,n);G.valid(e);G.next(e)) count++;
+      /// int count=0;
+      /// for(Graph::InEdgeIt e(g, n); g.valid(e); ++) ++count;
       /// \endcode
 
@@ -156,8 +173,15 @@
 	/// @warning The default constructor sets the iterator
 	/// to an undefined value.
-	InEdgeIt() {}
-	/// Initialize the iterator to be invalid
-	InEdgeIt(Invalid) {}
-	InEdgeIt(const StaticGraphSkeleton &, Node) {}    
+	InEdgeIt() { }
+	/// Copy constructor.
+	InEdgeIt(const InEdgeIt&) { }
+	/// Initialize the iterator to be invalid.
+	InEdgeIt(Invalid) { }
+	/// .
+	InEdgeIt(const StaticGraphSkeleton&, const Node&) { }
+	/// .
+	InEdgeIt(const StaticGraphSkeleton&, const Edge&) { }
+	/// Assign the iterator to the next inedge of the corresponding node.
+	InEdgeIt& operator++() { return *this; }
       };
       //  class SymEdgeIt : public Edge {};
@@ -167,8 +191,8 @@
       /// This iterator goes through each edge of a graph.
       /// Its usage is quite simple, for example you can count the number
-      /// of edges in a graph \c G of type \c Graph as follows:
+      /// of edges in a graph \c g of type \c Graph as follows:
       /// \code
-      ///int count=0;
-      ///for(Graph::EdgeIt e(G);G.valid(e);G.next(e)) count++;
+      /// int count=0;
+      /// for(Graph::EdgeIt e(g); g.valid(e); ++e) ++count;
       /// \endcode
       class EdgeIt : public Edge {
@@ -176,8 +200,14 @@
 	/// @warning The default constructor sets the iterator
 	/// to an undefined value.
-	EdgeIt() {}
-	/// Initialize the iterator to be invalid
-	EdgeIt(Invalid) {}
-	EdgeIt(const StaticGraphSkeleton &) {}
+	EdgeIt() { }
+	/// Copy constructor.
+	EdgeIt(const EdgeIt&) { }
+	/// Initialize the iterator to be invalid.
+	EdgeIt(Invalid) { }
+	/// .
+	EdgeIt(const StaticGraphSkeleton&) { }
+	/// .
+	EdgeIt(const StaticGraphSkeleton&, const Edge&) { } 
+	EdgeIt& operator++() { return *this; }
       };
 
@@ -187,13 +217,13 @@
       /// \return the first node.
       ///
-      NodeIt &first(NodeIt &i) const { return i;}
+      NodeIt& first(NodeIt& i) const { return i; }
 
       /// The first incoming edge.
-      InEdgeIt &first(InEdgeIt &i, Node) const { return i;}
+      InEdgeIt& first(InEdgeIt &i, Node) const { return i; }
       /// The first outgoing edge.
-      OutEdgeIt &first(OutEdgeIt &i, Node) const { return i;}
-      //  SymEdgeIt &first(SymEdgeIt &, Node) const { return i;}
+      OutEdgeIt& first(OutEdgeIt& i, Node) const { return i; }
+      //  SymEdgeIt& first(SymEdgeIt&, Node) const { return i; }
       /// The first edge of the Graph.
-      EdgeIt &first(EdgeIt &i) const { return i;}
+      EdgeIt& first(EdgeIt& i) const { return i; }
 
       //     Node getNext(Node) const {}
@@ -204,12 +234,12 @@
 
       /// Go to the next node.
-      NodeIt &next(NodeIt &i) const { return i;}
+      NodeIt& next(NodeIt& i) const { return i; }
       /// Go to the next incoming edge.
-      InEdgeIt &next(InEdgeIt &i) const { return i;}
+      InEdgeIt& next(InEdgeIt& i) const { return i; }
       /// Go to the next outgoing edge.
-      OutEdgeIt &next(OutEdgeIt &i) const { return i;}
-      //SymEdgeIt &next(SymEdgeIt &) const {}
+      OutEdgeIt& next(OutEdgeIt& i) const { return i; }
+      //SymEdgeIt& next(SymEdgeIt&) const { }
       /// Go to the next edge.
-      EdgeIt &next(EdgeIt &i) const { return i;}
+      EdgeIt& next(EdgeIt& i) const { return i; }
 
       ///Gives back the head node of an edge.
@@ -230,10 +260,10 @@
       ///\todo Maybe, it would be better if iterator converted to
       ///bool directly, as Jacint prefers.
-      bool valid(const Node&) const { return true;}
+      bool valid(const Node&) const { return true; }
       /// Checks if an edge iterator is valid
 
       ///\todo Maybe, it would be better if iterator converted to
       ///bool directly, as Jacint prefers.
-      bool valid(const Edge&) const { return true;}
+      bool valid(const Edge&) const { return true; }
 
       ///Gives back the \e id of a node.
@@ -241,10 +271,10 @@
       ///\warning Not all graph structures provide this feature.
       ///
-      int id(const Node&) const { return 0;}
+      int id(const Node&) const { return 0; }
       ///Gives back the \e id of an edge.
 
       ///\warning Not all graph structures provide this feature.
       ///
-      int id(const Edge&) const { return 0;}
+      int id(const Edge&) const { return 0; }
 
       /// Resets the graph.
@@ -252,9 +282,8 @@
       /// This function deletes all edges and nodes of the graph.
       /// It also frees the memory allocated to store them.
-      void clear() {}
-
-      int nodeNum() const { return 0;}
-      int edgeNum() const { return 0;}
-
+      void clear() { }
+
+      int nodeNum() const { return 0; }
+      int edgeNum() const { return 0; }
 
 
@@ -271,14 +300,12 @@
       public:
 
-	class ReferenceMap<Node,T>;
-
-	NodeMap(const StaticGraphSkeleton &) {}
-	NodeMap(const StaticGraphSkeleton &, T) {}
+	NodeMap(const StaticGraphSkeleton&) { }
+	NodeMap(const StaticGraphSkeleton&, T) { }
 
 	///Copy constructor
-	template<typename TT> NodeMap(const NodeMap<TT> &) {}
+	template<typename TT> NodeMap(const NodeMap<TT>&) { }
 	///Assignment operator
-	template<typename TT> NodeMap &operator=(const NodeMap<TT> &)
-	{return *this;}
+	template<typename TT> NodeMap& operator=(const NodeMap<TT>&)
+	{ return *this; }
       };
 
@@ -296,12 +323,12 @@
 	typedef Edge KeyType;
 
-	EdgeMap(const StaticGraphSkeleton &) {}
-	EdgeMap(const StaticGraphSkeleton &, T ) {}
+	EdgeMap(const StaticGraphSkeleton&) { }
+	EdgeMap(const StaticGraphSkeleton&, T) { }
     
 	///Copy constructor
-	template<typename TT> EdgeMap(const EdgeMap<TT> &) {}
+	template<typename TT> EdgeMap(const EdgeMap<TT>&) { }
 	///Assignment operator
-	template<typename TT> EdgeMap &operator=(const EdgeMap<TT> &)
-	{return *this;}
+	template<typename TT> EdgeMap &operator=(const EdgeMap<TT>&)
+	{ return *this; }
       };
     };
@@ -318,10 +345,10 @@
     public:
       /// Defalult constructor.
-      GraphSkeleton() {}
+      GraphSkeleton() { }
       ///Copy consructor.
 
       ///\todo It is not clear, what we expect from a copy constructor.
       ///E.g. How to assign the nodes/edges to each other? What about maps?
-      GraphSkeleton(const GraphSkeleton &G) {}
+      GraphSkeleton(const GraphSkeleton&) { }
 
       ///Add a new node to the graph.
@@ -329,5 +356,5 @@
       /// \return the new node.
       ///
-      Node addNode() { return INVALID;}
+      Node addNode() { return INVALID; }
       ///Add a new edge to the graph.
 
@@ -335,5 +362,5 @@
       ///and head node \c head.
       ///\return the new edge.
-      Edge addEdge(Node, Node) { return INVALID;}
+      Edge addEdge(Node, Node) { return INVALID; }
     
       /// Resets the graph.
@@ -342,5 +369,5 @@
       /// It also frees the memory allocated to store them.
       /// \todo It might belong to \c EraseableGraphSkeleton.
-      void clear() {}
+      void clear() { }
     };
 
@@ -353,12 +380,12 @@
     public:
       /// Deletes a node.
-      void erase(Node n) {}
+      void erase(Node n) { }
       /// Deletes an edge.
-      void erase(Edge e) {}
+      void erase(Edge e) { }
 
       /// Defalult constructor.
-      EraseableGraphSkeleton() {}
+      EraseableGraphSkeleton() { }
       ///Copy consructor.
-      EraseableGraphSkeleton(const GraphSkeleton &G) {}
+      EraseableGraphSkeleton(const GraphSkeleton&) { }
     };
 
Index: src/hugo/smart_graph.h
===================================================================
--- src/hugo/smart_graph.h	(revision 753)
+++ src/hugo/smart_graph.h	(revision 774)
@@ -122,10 +122,4 @@
     Node head(Edge e) const { return edges[e.n].head; }
 
-    Node aNode(OutEdgeIt e) const { return edges[e.n].tail; }
-    Node aNode(InEdgeIt e) const { return edges[e.n].head; }
-
-    Node bNode(OutEdgeIt e) const { return edges[e.n].head; }
-    Node bNode(InEdgeIt e) const { return edges[e.n].tail; }
-
     NodeIt& first(NodeIt& v) const { 
       v=NodeIt(*this); return v; }
@@ -137,39 +131,4 @@
       e=InEdgeIt(*this,v); return e; }
 
-//     template< typename It >
-//     It first() const { It e; first(e); return e; }
-
-//     template< typename It >
-//     It first(Node v) const { It e; first(e,v); return e; }
-
-    static bool valid(Edge e) { return e.n!=-1; }
-    static bool valid(Node n) { return n.n!=-1; }
-    
-    ///\deprecated Use
-    ///\code
-    ///  e=INVALID;
-    ///\endcode
-    ///instead.
-    static void setInvalid(Edge &e) { e.n=-1; }
-    ///\deprecated Use
-    ///\code
-    ///  e=INVALID;
-    ///\endcode
-    ///instead.
-    static void setInvalid(Node &n) { n.n=-1; }
-    
-    template <typename It> It getNext(It it) const
-    { It tmp(it); return next(tmp); }
-
-    NodeIt& next(NodeIt& it) const { 
-      it.n=(it.n+2)%(nodes.size()+1)-1; 
-      return it; 
-    }
-    OutEdgeIt& next(OutEdgeIt& it) const
-    { it.n=edges[it.n].next_out; return it; }
-    InEdgeIt& next(InEdgeIt& it) const
-    { it.n=edges[it.n].next_in; return it; }
-    EdgeIt& next(EdgeIt& it) const { --it.n; return it; }
-
     static int id(Node v) { return v.n; }
     static int id(Edge e) { return e.n; }
@@ -198,4 +157,20 @@
     }
 
+    /// Finds an edge between two nodes.
+
+    /// Finds an edge from node \c u to node \c v.
+    ///
+    /// If \c prev is \ref INVALID (this is the default value), then
+    /// It finds the first edge from \c u to \c v. Otherwise it looks for
+    /// the next edge from \c u to \c v after \c prev.
+    /// \return The found edge or INVALID if there is no such an edge.
+    Edge findEdge(Node u,Node v, Edge prev = INVALID) 
+    {
+      int e = (prev.n==-1)? nodes[u.n].first_out : edges[prev.n].next_out;
+      while(e!=-1 && edges[e].tail!=v.n) e = edges[e].next_out;
+      prev.n=e;
+      return prev;
+    }
+    
     void clear() {nodes.clear();edges.clear();}
 
@@ -219,14 +194,22 @@
       bool operator!=(const Node i) const {return n!=i.n;}
       bool operator<(const Node i) const {return n<i.n;}
+      //      ///Validity check
+      //      operator bool() { return n!=-1; }
     };
     
     class NodeIt : public Node {
+      const SmartGraph *G;
       friend class SmartGraph;
     public:
       NodeIt() : Node() { }
+      NodeIt(const SmartGraph& _G,Node n) : Node(n), G(&_G) { }
       NodeIt(Invalid i) : Node(i) { }
-      NodeIt(const SmartGraph& G) : Node(G.nodes.size()?0:-1) { }
-      ///\todo Undocumented conversion Node -\> NodeIt.
-      NodeIt(const SmartGraph& G, const Node &n) : Node(n) { }
+      NodeIt(const SmartGraph& _G) : Node(_G.nodes.size()?0:-1), G(&_G) { }
+      NodeIt &operator++() {
+	n=(n+2)%(G->nodes.size()+1)-1; 
+	return *this; 
+      }
+//       ///Validity check
+//       operator bool() { return Node::operator bool(); }      
     };
 
@@ -258,11 +241,15 @@
       ///make class \c SymSmartGraph::SymEdgeMap friend of Edge
       int &idref() {return n;}
-      const int &idref() const {return n;}
-    };
+      const int &idref() const {return n;} 
+//       ///Validity check
+//       operator bool() { return n!=-1; }
+   };
     
     class EdgeIt : public Edge {
+      const SmartGraph *G;
       friend class SmartGraph;
     public:
-      EdgeIt(const SmartGraph& G) : Edge(G.edges.size()-1) { }
+      EdgeIt(const SmartGraph& _G) : Edge(_G.edges.size()-1), G(&_G) { }
+      EdgeIt(const SmartGraph& _G, Edge e) : Edge(e), G(&_G) { }
       EdgeIt (Invalid i) : Edge(i) { }
       EdgeIt() : Edge() { }
@@ -270,22 +257,36 @@
       ///make class \c SymSmartGraph::SymEdgeMap friend of Edge
       int &idref() {return n;}
+      EdgeIt &operator++() { --n; return *this; }
+//       ///Validity check
+//       operator bool() { return Edge::operator bool(); }      
     };
     
     class OutEdgeIt : public Edge {
+      const SmartGraph *G;
       friend class SmartGraph;
     public: 
       OutEdgeIt() : Edge() { }
+      OutEdgeIt(const SmartGraph& _G, Edge e) : Edge(e), G(&_G) { }
       OutEdgeIt (Invalid i) : Edge(i) { }
 
-      OutEdgeIt(const SmartGraph& G,const Node v)
-	: Edge(G.nodes[v.n].first_out) {}
+      OutEdgeIt(const SmartGraph& _G,const Node v)
+	: Edge(_G.nodes[v.n].first_out), G(&_G) {}
+      OutEdgeIt &operator++() { n=G->edges[n].next_out; return *this; }
+//       ///Validity check
+//       operator bool() { return Edge::operator bool(); }      
     };
     
     class InEdgeIt : public Edge {
+      const SmartGraph *G;
       friend class SmartGraph;
     public: 
       InEdgeIt() : Edge() { }
+      InEdgeIt(const SmartGraph& _G, Edge e) : Edge(e), G(&_G) { }
       InEdgeIt (Invalid i) : Edge(i) { }
-      InEdgeIt(const SmartGraph& G,Node v) :Edge(G.nodes[v.n].first_in){}
+      InEdgeIt(const SmartGraph& _G,Node v)
+	: Edge(_G.nodes[v.n].first_in), G(&_G) { }
+      InEdgeIt &operator++() { n=G->edges[n].next_in; return *this; }
+//       ///Validity check
+//       operator bool() { return Edge::operator bool(); }      
     };
 
Index: src/hugo/unionfind.h
===================================================================
--- src/hugo/unionfind.h	(revision 649)
+++ src/hugo/unionfind.h	(revision 774)
@@ -6,4 +6,7 @@
 //!\file
 //!\brief Union-Find data structures.
+//!
+//!\bug unionfind_test.cc doesn't work with Intel compiler. It compiles but
+//!fails to run (Segmentation fault).
 
 
